#include <stdio.h>
#include <stdlib.h>

void preencheMatriz (int **matriz, int linhas, int colunas);
void aponta (int ***ponteiroMatriz, int **matriz, int linhas, int colunas);
void swap (int ***ponteiroMatriz, int linhas, int colunas);
void swapRow (int ***ponteiroMatriz, int linhas, int colunas);
void swapColumn (int ***ponteiroMatriz, int linhas, int colunas);
void imprimeMatrizInicial (int **matriz, int linhas, int colunas);
void print (int ***ponteiroMatriz, int linhas, int colunas);

int main()
{
    int **matriz, ***ponteiroMatriz, linhas, colunas, i, opcao;
    do //pede o numero de linhas e colunas at que sejam vlidas
    {
        printf ("Digite a quantidade de linhas da matriz: ");
        scanf ("%d", &linhas);
        printf ("Digite a quantidade de colunas da matriz: ");
        scanf ("%d", &colunas);
        if (linhas <= 0 || colunas <= 0)
        {
            printf ("\nNumeros invalidos!!\n\n");
        }
    }
    while (linhas <= 0 || colunas <= 0);
    //aloca a matriz e a matriz de ponteiros
    matriz = (int **) malloc (linhas * sizeof (int *));
    ponteiroMatriz = (int ***) malloc (linhas * sizeof (int **));
    for (i = 0; i < linhas; i++)
    {
        matriz[i] = (int *) malloc (colunas * sizeof (int));
        ponteiroMatriz[i] = (int **) malloc (colunas * sizeof (int *));
    }

    preencheMatriz (matriz, linhas, colunas); //chama a funo que preenche a matriz
    aponta (ponteiroMatriz, matriz, linhas, colunas); //chama a funo que aponta a matriz de ponteiros para a matriz

    do //pede a opo at que seja digitado 5, que encerra o programa
    {
        printf ("\n\nDigite a opcao desejada:\n1 para Swap \n2 para Swap Row \n3 para Swap Column \n4 para Print \n5 para sair\n");
        scanf ("%d", &opcao); //pega a opo desejada
        switch (opcao)
        {
            case 1:
            {
                swap (ponteiroMatriz, linhas, colunas); //chama a funo swap
                break;
            }
            case 2:
            {
                swapRow (ponteiroMatriz, linhas, colunas); //chama a funo swap row
                break;
            }
            case 3:
            {
                swapColumn (ponteiroMatriz, linhas, colunas); //chama a funo swap column
                break;
            }
            case 4:
            {
                imprimeMatrizInicial (matriz, linhas, colunas); //chama a funo para imprimir a matriz original
                print (ponteiroMatriz, linhas, colunas); //chama a funo swap
                break;
            }
            case 5:
            {
                //desaloca a matriz e a matriz de ponteiros
                for (i = 0; i < linhas; i++)
                {
                    free (matriz[i]);
                    free (ponteiroMatriz[i]);
                }
                free (matriz);
                free (ponteiroMatriz);
                break;
            }
            default:
            {
                printf ("\n\nOpcao Invalida!!\n\n");
            }
        }
    }
    while (opcao != 5);

    return 0;
}

void preencheMatriz (int **matriz, int linhas, int colunas) //funo que preenche a matriz
{
    int i, j;
    for (i = 0; i < linhas; i++)
    {
        for (j = 0; j < colunas; j++)
        {
            printf ("Digite o elemento [%d][%d] da matriz: ", i, j);
            scanf ("%d", &matriz[i][j]); //pega o elemento ij da matriz
        }
    }
}

void aponta (int ***ponteiroMatriz, int **matriz, int linhas, int colunas)//funo que aponta a matriz de ponteiros para a matriz
{
    int i, j;
    for (i = 0; i < linhas; i++)
    {
        for (j = 0; j < colunas; j++)
        {
            ponteiroMatriz[i][j] = &matriz[i][j];
        }
    }
}


void swap (int ***ponteiroMatriz, int linhas, int colunas)//funo que troca o lugar que dois ponteiros apontam entre si
{
    int i1, j1, i2, j2;
    int *aux;
    do //condies para o elemento ser vlido
    {
        printf ("Digite o elemento [i1] [j1] que voce deseja trocar separados por um espaco: ");
        scanf ("%d %d", &i1, &j1);
        if (i1 >= linhas || i1 < 0 || j1 >= colunas || j1 < 0)
        {
            printf ("\nElementos invalidos!!!\n\n");
        }
    }
    while (i1 >= linhas || i1 < 0 || j1 >= colunas || j1 < 0);

    do //condies para o elemento ser vlido
    {
        printf ("Digite o elemento [i2] [j2] que voce deseja trocar por [i1] [j1] separados por um espaco: ");
        scanf ("%d %d", &i2, &j2);
        if (i2 >= linhas || i2 < 0 || j2 >= colunas || j2 < 0)
        {
            printf ("\nElementos invalidos!!!\n\n");
        }
    }
    while (i2 >= linhas || i2 < 0 || j2 >= colunas || j2 < 0);
    //troca o lugar para onde os elementos esto apontando
    aux = ponteiroMatriz[i1][j1];
    ponteiroMatriz[i1][j1] = ponteiroMatriz[i2][j2];
    ponteiroMatriz[i2][j2] = aux;
}

void swapRow (int ***ponteiroMatriz, int linhas, int colunas) //funo que troca as linhas de onde a matriz de ponteiros aponta
{
    int i1, i2, cont;
    int *aux;
    do //condio para a linha i1 ser vlida
    {
        printf ("Digite a linha i1 que voce deseja trocar: ");
        scanf ("%d", &i1);
        if (i1 >= linhas || i1 < 0)
        {
            printf ("\nLinha invalida!!!\n\n");
        }
    }
    while (i1 >= linhas || i1 < 0);

    do //condio para a linha i2 ser vlida
    {
        printf ("Digite a linha i2 que voce deseja trocar pela i1 : ");
        scanf ("%d", &i2);
        if (i2 >= linhas || i2 < 0)
        {
            printf ("\nLinha invalida!!!\n\n");
        }
    }
    while (i2 >= linhas || i2 < 0);

    for (cont = 0 ; cont < colunas; cont++) //troca o lugar para onde os ponteiros apontam em todas as colunas
    {
        aux = ponteiroMatriz[i1][cont];
        ponteiroMatriz[i1][cont] = ponteiroMatriz[i2][cont];
        ponteiroMatriz[i2][cont] = aux;
    }

}

void swapColumn (int ***ponteiroMatriz, int linhas, int colunas) //funo que troca as colunas de onde a matriz de ponteiros aponta
{
    int j1, j2, cont;
    int *aux;
    do //condio para a coluna j1 ser vlida
    {
        printf ("Digite a coluna j1 que voce deseja trocar: ");
        scanf ("%d", &j1);
        if (j1 >= colunas || j1 < 0)
        {
            printf ("\nColuna invalida!!!\n\n");
        }
    }
    while (j1 >= colunas || j1 < 0);

    do //condio para a coluna j2 ser vlida
    {
        printf ("Digite a coluna j2 que voce deseja trocar pela j1 : ");
        scanf ("%d", &j2);
        if (j2 >= colunas || j2 < 0)
        {
            printf ("\nColuna invalida!!!\n\n");
        }
    }
    while (j2 >= colunas || j2 < 0);

    for (cont = 0 ; cont < linhas; cont++) //troca o lugar para onde os ponteiros apontam em todas as linhas
    {
        aux = ponteiroMatriz[cont][j1];
        ponteiroMatriz[cont][j1] = ponteiroMatriz[cont][j2];
        ponteiroMatriz[cont][j2] = aux;
    }
}

void imprimeMatrizInicial (int **matriz, int linhas, int colunas) //funo que imprime a matriz original
{
    int i, j;
    printf ("\nMatriz Inicial: \n");
    for (i = 0; i < linhas; i++)
    {
        for (j = 0; j < colunas; j++)
        {
            printf ("%d ", matriz[i][j]);
        }
        printf ("\n");
    }
}

void print (int ***ponteiroMatriz, int linhas, int colunas) //funo que imprime a matriz modifica
{
    int i, j;
    printf ("\nMatriz Final: \n");
    for (i = 0; i < linhas; i++)
    {
        for (j = 0; j < colunas; j++)
        {
            printf ("%d ", *(ponteiroMatriz[i][j])); //imprime para onde o elemento do ponteiro est apontando
        }
        printf ("\n");
    }
}


